#ifndef AUDIO_HPP
#define AUDIO_HPP

#include <string>
#include <vector>
#include <iostream>
#include <boost/foreach.hpp>
#define foreach BOOST_FOREACH

#include "fmod/fmod.h"
#include "fmod/fmod_errors.h"

using namespace std;

class SoundEngine {
public:
  void loadsound(const string& s);
  void play(int i);
  void streamtrack(const string& s);
  void startdsp();
  void setnoisevol(float v);
  void amplify();
  void diminish();
  SoundEngine();
  ~SoundEngine();
private:
  FMOD_DSP *dsp;
  FMOD_CHANNEL* dspchannel;
  FMOD_SYSTEM* fmod_system;
  vector<FMOD_SOUND*> sounds;
  vector <FMOD_CHANNEL*> channels;
  void ERRCHECK(FMOD_RESULT result);
  float curvol;
};

#endif /* AUDIO_HPP */
