#include "enginepart.hpp"

EnginePart::~EnginePart()
{

}

int EnginePart::run()
{
    if (fadeincounter==0)
        fadeincounter=40;
    else
        fadeincounter=0;

    while(true)
    {
        timer->start();

        SDL_Event event;

        int message;

        while( SDL_PollEvent( &event ) )
        {
          if (fadeincounter==0)
          {
                //update mouse
              Uint8 a=SDL_BUTTON(SDL_GetMouseState(&mx, &my));
              mb1=a==SDL_BUTTON_LEFT;

              mb2=false;

              if (event.type==SDL_MOUSEBUTTONDOWN)
              {
                if (event.button.button==SDL_BUTTON_RIGHT)
                {
                    mb2=true;
                }
              }

              message=input(event);
              if (message!=0)
                return message;
          }
        }


        if (fadeincounter==0)
        {
            message=logic();
            if (message!=0)
              return message;
        }

        draw();

        if (fadeincounter>0)
        {
            glColor4f(1,1,1,1);
            graphicsengine->drawstipple(((float)(fadeincounter))/40.0f);
            soundengine->setnoisevol(0.1f*(1.0f-((float)(fadeincounter))/40.0f));
            fadeincounter--;
        }

        graphicsengine->flip();

        if( timer->get_ticks() < 1000 / FRAMES_PER_SECOND )
        {
            SDL_Delay( ( 1000 / FRAMES_PER_SECOND ) - timer->get_ticks() );
        }
    }

    return 0;
}

EnginePart::EnginePart(const SubengineInterface* subengines)
{
  timer=subengines->timer;
  graphicsengine=subengines->graphicsengine;
  soundengine=subengines->soundengine;
}
