#ifndef FONT_HPP
#define FONT_HPP

#include <iostream>
#include <sstream>
using namespace std;

#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"

class FontRenderer
{
public:
  void glPrint( GLint x, GLint y, const char *string, int set );
  void glPrintMultiLine( GLint x, GLint y, int width, const char *str, int set );
  void glSmallPrint( GLint x, GLint y, const char *string, int set );
  //the following also accepts newlines
  void glSmallPrintMultiLine( GLint x, GLint y, int width, const char *str, int set );
  void glSmallPrintAlignRight( GLint x, GLint y, const char *string, int set );
  void glSmallPrintNum( GLint x, GLint y, int n);
  FontRenderer();
  ~FontRenderer();
private:
  GLuint  base;                  /* Base Display List For The Font           */
  GLuint  smallbase;                  /* Base Display List For The Font           */
  GLuint  font_texture; /* Storage For Our Font Texture             */
  GLuint  smallfont_texture; /* Storage For Our Font Texture             */
  GLuint  loop;                  /* Generic Loop Variable                    */
  GLfloat cnt1;                  /* Counter Used To Move Text & For Coloring */
  GLfloat cnt2;                  /* Counter Used To Move Text & For Coloring */
  private:
  void BuildFont();
};


string format_grouping  (int value);


#endif /* FONT_HPP */
