#ifndef GRAPHICS_HPP
#define GRAPHICS_HPP

#include <iostream>
#include <boost/foreach.hpp>
#define foreach BOOST_FOREACH

#include "graphicsheader.hpp"
#include "font.hpp"
#include "icons.hpp"
#include "audio.hpp"

const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
const int SCREEN_BPP = 32;

class GraphicsEngine {
public:
  FontRenderer* fontrenderer;
  IconRenderer* iconrenderer;
  void flip();
  GraphicsEngine();
  void drawstipple(float alpha);
  int resizeWindow( int width, int height );
  void fadetoblack(SoundEngine* s);
  void drawpane(int x1, int x2, int y1, int y2);
private:
  void initGL();
  SDL_Surface* screen;
};

#endif /* GRAPHICS_HPP */
