#include "icons.hpp"


/* function to recover memory form our list of characters */
IconRenderer::~IconRenderer( GLvoid )
{
    glDeleteLists( base, 8*5 );
    return;
}

IconRenderer::IconRenderer( )
{
    /* Status indicator */
    int Status = 0;


    //LOAD THE ICON TEXTURE
    {
        /* Create storage space for the texture */
        SDL_Surface *TextureImage;

        /* Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit */
        if ( TextureImage = SDL_LoadBMP( "textures/icons.bmp" ) )
        {


            /* Set the status to true */
            Status = 1;

            /* Create The Texture */
            glGenTextures( 1, &icon_texture );

            /* Load in texture 1 */
            /* Typical Texture Generation Using Data From The Bitmap */
            glBindTexture( GL_TEXTURE_2D, icon_texture );

            /* Generate The Texture */
            glTexImage2D( GL_TEXTURE_2D, 0, 3, TextureImage->w,
                          TextureImage->h, 0, GL_BGR,
                          GL_UNSIGNED_BYTE, TextureImage->pixels );

            /* Nearest Filtering */
            glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
            glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );

        }

        /* Free up any memory we may have used */
        if ( TextureImage )
            SDL_FreeSurface( TextureImage );
    }


    BuildIcon();
}


/* function to build our font list */
void  IconRenderer::BuildIcon()
{
    base  = glGenLists( 8*8 );
    /* Select Our Font Texture */
    glBindTexture( GL_TEXTURE_2D, icon_texture );

    for (int j=0;j<8;j++)
    for (int i=0;i<8;i++)
    {
        /* Start Building A List */
        glNewList( base+8*j+i, GL_COMPILE );


        float tilesize=(1.0f/8.0f);
        glEnable(GL_TEXTURE_2D);
        /* Use A Quad For Each Character */
        glBegin( GL_QUADS );
        /* Texture Coord (Bottom Left) */
        glTexCoord2f(i*tilesize+0,j*tilesize+ tilesize );
        /* Vertex Coord (Bottom Left) */
        glVertex2i( 0, 64 );

        /* Texture Coord (Bottom Right) */
        glTexCoord2f( i*tilesize+tilesize, j*tilesize+tilesize );
        /* Vertex Coord (Bottom Right) */
        glVertex2i( 64, 64 );

        /* Texture Coord (Top Right) */
        glTexCoord2f(i*tilesize+tilesize,j*tilesize+0);
        /* Vertex Coord (Top Right) */
        glVertex2i( 64, 0 );

        /* Texture Coord (Top Left) */
        glTexCoord2f(i*tilesize+ 0, j*tilesize+0);
        /* Vertex Coord (Top Left) */
        glVertex2i( 0, 0);
        glEnd( );

        glDisable(GL_TEXTURE_2D);


        glEndList( );
    }
}


void IconRenderer::glIcon( GLint x, GLint y, int icon )
{
     glBindTexture( GL_TEXTURE_2D, icon_texture );

    /* Select The Projection Matrix */
    glMatrixMode( GL_PROJECTION );
    /* Store The Projection Matrix */
    glPushMatrix( );

    /* Reset The Projection Matrix */
    glLoadIdentity( );
    /* Set Up An Ortho Screen */
    glOrtho( 0, 640, 480, 0, -1, 1 );

    /* Select The Modelview Matrix */
    glMatrixMode( GL_MODELVIEW );
    /* Stor the Modelview Matrix */
    glPushMatrix( );
    /* Reset The Modelview Matrix */
    glLoadIdentity( );

    /* Position The Text (0,0 - Bottom Left) */
    glTranslated( x, y, 0 );

    glCallList(base+icon);

    /* Select The Projection Matrix */
    glMatrixMode( GL_PROJECTION );
    /* Restore The Old Projection Matrix */
    glPopMatrix( );

    /* Select the Modelview Matrix */
    glMatrixMode( GL_MODELVIEW );
    /* Restore the Old Projection Matrix */
    glPopMatrix( );

}
