#include "engineinstance.hpp"

#include "intropart.hpp"
#include "titlepart.hpp"
#include "mainpart.hpp"

GameEngine::GameEngine()
{
//    savedata->setmaxlevel(0);

    global_variables = new Global_Variables();
	soundengine->loadsound("audio/blipn.wav");
	soundengine->loadsound("audio/bigblip.wav");
	soundengine->loadsound("audio/good.wav");
	soundengine->loadsound("audio/bad.wav");
//  soundengine->loadsound("audio/pickup.wav");
//  soundengine->loadsound("audio/steps.wav");
            soundengine->startdsp();
//    soundengine->streamtrack("audio/0.mp3");

    section.push_back(new IntroPart ( this , global_variables ) );
    section.push_back(new TitlePart ( this , global_variables ) );
    section.push_back(new MainPart  ( this , global_variables ) );

}

GameEngine::~GameEngine()
{
}


int GameEngine::control(int oldpart, int message)
{
    if (message<0)
        return -1;

    switch (oldpart)
    {
    case 0://intro
        return 1;
        break;
    case 1://title
        return 2;//goto level select
        break;
    case 2://main game
        switch (message)
        {
        case 1://finish level
			//soundengine->streamtrack("audio/0.mp3");
			if (global_variables->level<6)
                return 2;//go back to level select screen
            else
                return 1;
            break;
        case 3:
			//soundengine->streamtrack("audio/0.mp3");
            return 1;
            break;
        default://should never get her
            return -1;
            break;
        }
        break;
    }
    return -1;
}
