#include "titlepart.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"
#include <math.h>



void TitlePart::reset()
{
    curselected=0;
//DOES NOT RESET
}

TitlePart::TitlePart(const SubengineInterface* subengines, Global_Variables* p_global_variables):
        EnginePart(subengines),
        state(new TitlePart_State),
        global_variables(p_global_variables)
{

    curselected=0;
};

TitlePart::~TitlePart()
{
    delete state;
}

int TitlePart::input(const SDL_Event& event)
{

    if ( event.type == SDL_KEYDOWN )
    {
        switch ( event.key.keysym.sym )
        {
        case SDLK_ESCAPE:
            return -1;
            break;
        case SDLK_UP:
        case SDLK_DOWN:
            curselected=(curselected+1) % 2;
            soundengine->play(0);
            break;
        case SDLK_SPACE:
        {
            if (curselected==0)
            {
                global_variables->level=0;
                soundengine->play(1);
                return 1;
            }
            else
                return -1;
        }
        default:
            break;
        }
    }


    return 0;
}

int TitlePart::logic()
{
    return 0;
}

void TitlePart::draw()
{
    glClearColor(0,0,0,1);
    glClear( GL_COLOR_BUFFER_BIT  );
    glDisable(GL_TEXTURE_2D);


    if (curselected==0)
        glColor3f(1.0f,1.0f,1.0f);
    else
        glColor3f(0.5f,0.5f,0.5f);

    graphicsengine->fontrenderer->glPrint(253,258,"begin",0);

    if (curselected==0)
        glColor3f(0.5f,0.5f,0.5f);
    else
        glColor3f(1.0f,1.0f,1.0f);


    graphicsengine->fontrenderer->glPrint(253,299,"quit",0);

    glColor3f(1.0f,1.0f,1.0f);
    glColor3f(1.0f,1.0f,1.0f);

    string s="signifier";
    int r=rand()%s.size();

    graphicsengine->fontrenderer->glPrint(253-1+rand()%2,176-1+rand()%2,s.substr(0,r+1).c_str(),0);
    graphicsengine->fontrenderer->glPrint(253+(r+1)*16,176,s.substr(r+1,s.size()-r).c_str(),0);

}
