#include "widget.hpp"

bool Screen_Element::isat(int px, int py)
{
	if (((px>=x)  &&
	(px<x+w))&&
	((py>=y)&&
	(py<y+h)))
		return true;
	else
		return false;
}




void Set_Button::draw()
{
    if (enabled)
    {
        switch(state)
        {
                case bs_normal:
                {
                    if (on)
                    {
                        glColor4f(1.0f,1.0f,1.0f,1.0f);
                    }
                    else
                    {
                        glColor4f(0.4f,0.4f,0.4f,1.0f);
                    }
                }
                break;
                case bs_down:
                    {
                        glColor4f(0.3f,0.3f,0.3f,1.0f);
                    }
                break;
        }
    }
    else
    {
        glColor4f(0.0f,0.0f,0.0f,0.0f);
    }

    iconrenderer->glIcon(x,y,image);
}

static void rect(GLfloat x1,GLfloat y1,GLfloat x2,GLfloat y2)
{
    glBegin(GL_LINE_LOOP);
    glVertex2f(x1,y1);
    glVertex2f(x2,y1);
    glVertex2f(x2,y2);
    glVertex2f(x1,y2);
    glEnd();
}

void Text_Button::draw()
{
    if (enabled)
    {
        switch(state)
        {
                case bs_normal:
                {
                    if (on)
                    {
                        glColor4f(1.0f,1.0f,1.0f,1.0f);
                    }
                    else
                    {
                        glColor4f(0.4f,0.4f,0.4f,1.0f);
                    }
                }
                break;
                case bs_down:
                    {
                        glColor4f(0.3f,0.3f,0.3f,1.0f);
                    }
                break;
        }
    }
    else
    {
        glColor4f(0.0f,0.0f,0.0f,1.0f);
    }

    rect(x-3,y+3+16,x+strlen(text)*16+3,y-3);
    fontrenderer->glPrint(x,y,text,0);
}

void Set_Button::uncapture()
{
    state=bs_normal;
}

void Set_Button::mouseinput(int mx, int my, bool mb1)
{
	switch (state)
	{
        case bs_normal:
        {
            if (mb1)
                state=bs_down;
        }
        break;
        case bs_down:
        {
            if (!mb1)
            {
                    if (isat(mx,my))
                    {
                        //click
                        onclick(param, on);
                        state=bs_normal;
                    }
                    else
                    {
                        state=bs_normal;
                    }
            }
        }
        break;
	}
}

void Level_Select_Bar::draw()
{
    glColor4f(0.5f,0.5f,1.0f,1.0f);
    rect(x,y,x+w,y+h);
    float width=((float)(w-8)) / (float) (boxcount);
    for (int i=0;i<boxcount;i++)
    {
        glColor4f(0.14f,0.85f,0.10f,1.0f);
        rect(x+8+width*i,y+8,x+4+width*(i+1)-4,y+h-8);
        if (i==curselected)
        {
            glColor4f(1.0f, 0.85f, 0.3f,1.0f);
            rect(x+8+width*i+8,y+8+8,x+4+width*(i+1)-4-8,y+h-8-8);
        }

        if (i<curmaxlevel)
        {
            glColor4f(0.74f,0.85f,0.10f,1.0f);
            rect(x+8+width*i+4,y+8+4,x+4+width*(i+1)-4-4,y+h-8-4);
        }
        else if (i==curmaxlevel)
        {
            glColor4f(1.0f,1.0f,0.50f,1.0f);
            rect(x+8+width*i+4,y+8+4,x+4+width*(i+1)-4-4,y+h-8-4);
        }
    }
    glColor4f(0.91f, 0.64f, 0.24f,1.0f);
    rect(x+4,y+4,x+4+width*(((float)curselected)+0.5f),y+h-4);

}

void Level_Select_Bar::mouseinput(int mx, int my, bool mb1)
{
    if (!mb1)
        return;

    int rmx=mx-x-6;
    int rmy=my-y-6;


//box width
    float width=((float)(w-8)) / (float) (boxcount);
    curselected = max(min((int)(rmx/width),curmaxlevel),0);

}
